VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "BMP Resource Compiler Tool"
   ClientHeight    =   2775
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4650
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2775
   ScaleWidth      =   4650
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSelectFile 
      Caption         =   "Select *.RC File"
      Height          =   540
      Left            =   135
      TabIndex        =   4
      Top             =   1995
      Visible         =   0   'False
      Width           =   1365
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Default         =   -1  'True
      Height          =   540
      Left            =   1620
      TabIndex        =   8
      Top             =   1995
      Width           =   1365
   End
   Begin VB.TextBox tbxFile 
      Height          =   330
      Left            =   1215
      TabIndex        =   2
      ToolTipText     =   "RC file to be created in Source Folder. Be sure to include rc extension."
      Top             =   630
      Width           =   3255
   End
   Begin VB.CommandButton cmdCompile 
      Caption         =   "Compile *.RES file"
      Height          =   540
      Left            =   3105
      TabIndex        =   6
      ToolTipText     =   "Compile RES file in source folder"
      Top             =   1260
      Width           =   1365
   End
   Begin VB.CommandButton cmdCreateFile 
      Caption         =   "Create *.RC File"
      Height          =   540
      Left            =   1620
      TabIndex        =   5
      ToolTipText     =   "Create RC file in source folder"
      Top             =   1260
      Width           =   1365
   End
   Begin VB.CommandButton cmdSelectFolder 
      Caption         =   "Select BMP Source Folder"
      Height          =   540
      Left            =   135
      TabIndex        =   3
      ToolTipText     =   "Browse to project source folder."
      Top             =   1260
      Width           =   1365
   End
   Begin VB.TextBox tbxFolder 
      Height          =   330
      Left            =   1215
      TabIndex        =   0
      ToolTipText     =   "Project Source Folder where bmp's reside"
      Top             =   210
      Width           =   3255
   End
   Begin VB.Label Label2 
      Caption         =   "Resource File:"
      Height          =   225
      Left            =   135
      TabIndex        =   7
      Top             =   630
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Source Folder:"
      Height          =   225
      Left            =   135
      TabIndex        =   1
      Top             =   210
      Width           =   1095
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Project Constants
Private Const strAppName As String = "ResourceTool"

'API Constants
Private Const MAX_PATH = 2600

'API Types
Private Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

'Declares
Private Declare Function SHBrowseForFolder Lib "shell32.dll" _
Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long

Private Declare Function SHGetPathFromIDList Lib "shell32.dll" _
Alias "SHGetPathFromIDListA" (ByVal pidl As Long, _
ByVal pszPath As String) As Long

Private Function ReturnFolder(DialogTitle As String) As String
  Dim Browser As BROWSEINFO
  Dim lngFolder As Long
  Dim strPath As String
  With Browser
    .hOwner = 0&
    .lpszTitle = DialogTitle
    .pszDisplayName = String(MAX_PATH, 0)
  End With
  strPath = String(MAX_PATH, 0) '<-- VERY Important!!
  lngFolder = SHBrowseForFolder(Browser)
  If lngFolder Then
    SHGetPathFromIDList lngFolder, strPath
    ReturnFolder = Left(strPath, InStr(strPath, vbNullChar) - 1)
  End If
End Function

Private Sub cmdClose_Click()
     SaveSetting strAppName, "Defaults", "BMPFolder", tbxFolder.Text
     SaveSetting strAppName, "Defaults", "ResourceFile", tbxFile.Text
     Unload Me
End Sub

Private Sub cmdCompile_Click()
    If tbxFile.Text <> "" Then
        ChDrive Left(tbxFolder.Text, 2)
        ChDir tbxFolder
        Shell """C:\Program Files\Microsoft Visual Studio\VB98\Wizards\rc.exe"" -r """ & tbxFile.Text & ""
        MsgBox "RES file was created from:" & vbCrLf & tbxFile.Text, vbInformation, "RES Created"
    Else
        MsgBox "Please enter a filename.", vbInformation, "Compile Resource File"
    End If
End Sub

Private Sub cmdCreateFile_Click()
    Dim fn As Integer
    Dim strFile1 As String
    Dim strFile2 As String
    
    If tbxFile = "" Then
        Exit Sub
    Else
        'build text file
        'open it
        fn = FreeFile
        Open tbxFolder.Text & "\" & tbxFile.Text For Output Access Write As fn
        strFile2 = Dir(tbxFolder.Text & "\*.bmp")
        strFile1 = Left(strFile2, Len(strFile2) - 4)
        While strFile2 <> ""
            strFile1 = Left(strFile2, Len(strFile2) - 4)
            If Len(strFile1) >= 14 Then
                Print #fn, strFile1; Tab; "BITMAP"; Tab; strFile2
            Else
                Print #fn, strFile1; Tab; Tab; "BITMAP"; Tab; strFile2
            End If
            strFile2 = Dir()
        Wend
        Close fn
        Shell "Notepad """ & tbxFolder.Text & "\" & tbxFile.Text & "", vbNormalFocus
    End If
    
End Sub

Private Sub cmdSelectFile_Click()
    Dim oDialog As New FileDialogs
    'Get filename to build
    With oDialog
        .Filter = "C+ resource (*.rc)|*.rc"
        .StartInDir = tbxFolder.Text
        .OwnerHwnd = Me.hWnd
        .Title = "Select *.rc file."
    End With
    tbxFile.Text = oDialog.ShowOpen

End Sub

Private Sub cmdSelectFolder_Click()
    tbxFolder = ReturnFolder("Select BMP Folder")
End Sub

Private Sub Form_Load()
    tbxFolder.Text = GetSetting(strAppName, "Defaults", "BMPFolder")
    tbxFile.Text = GetSetting(strAppName, "Defaults", "ResourceFile")
End Sub
